<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                template="./../plantilla-principal.xhtml"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">

    <ui:define name="contenido">
        <f:metadata>
            <f:event type="preRenderView" listener="#{sessionManBean.modulosFuncionalidad(8)}"></f:event>
        </f:metadata>
        <h:form id="form-acciones" class="ui menu">
            <div class="borderless header item">
                <div style="font-size: 22px">
                    <i class="money bill alternate outline icon" />
                    Cobros
                </div>
            </div>
            <div class="right menu">
                <div class="ui right aligned category search item">
                    <div class="ui transparent icon input">
                        <input id="txf-buscar" class="prompt" type="text" placeholder="Buscar..." />
                        <i id="icono-busqueda" class="search link icon"></i>
                    </div>
                    <div class="results"></div>
                </div>
                <div class="item">
                    <h:commandLink rendered="#{sessionManBean.permisosAsignados(44)}" id="btn-imprimir" style="#{cobrosManBean.paginador.isEmpty()?'display: none':''}" class="ui icon button" action="#{cobrosManBean.vistaPreviaImpresion()}" pt:data-tooltip="Vista previa de impresión" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="print icon" />                       
                    </h:commandLink>
                    <a href="cobroporfactura.xhtml" style="#{not sessionManBean.permisosAsignados(45)?'display: none;':''} margin-left: 5px;" data-tooltip="Registrar cobros de facturas..." data-inverted="" data-position="bottom right" class="ui green icon button">
                        <i class="list alternate outline icon" />
                    </a>
                    <button style="display: none;" id="btn-cobros-fact" class="ui blue icon button" data-tooltip="Registrar cobros de facturas..." data-inverted="" data-position="bottom right">
                        <i class="newspaper icon" />
                    </button>
                </div>
            </div>
        </h:form>
        <div class="ui grid">
            <div class="eleven wide column">
                <h:form id="form-tabla">
                    <table class="ui celled table" id="tabla-datos">
                        <thead>
                            <tr>
                                <th>Cobrador</th>
                                <th>Cliente</th>
                                <th>F. Cobro</th>
                                <th>Concepto</th>
                                <th>Factura</th>
                                <th class="right aligned">Monto</th>
                            </tr>
                        </thead>
                        <tbody jsf:id="tbody-tabla">
                            <tr>
                                <td jsf:rendered="#{empty cobrosManBean.lstCobros}" colspan="4">(Sin Registros)</td>
                            </tr>
                            <ui:repeat value="#{cobrosManBean.lstCobros}" var="cobro" varStatus="cobroStatus">
                                <tr class="#{cobro.anulado?'negative':''}">

                                    <td>#{cobro.cobrador.nombres} #{cobro.cobrador.apellidos}</td>
                                    <td data-tooltip="Cod. Cliente: #{cobro.suscripcion.cliente.idcliente} | CI/RUC: #{not empty cobro.suscripcion.cliente.ci?cobro.suscripcion.cliente.ci:'(No registrado)'}#{not empty cobro.suscripcion.cliente.ci &amp;&amp; not empty cobro.suscripcion.cliente.dvRuc?'-':''}#{not empty cobro.suscripcion.cliente.ci &amp;&amp; not empty cobro.suscripcion.cliente.dvRuc?cobro.suscripcion.cliente.dvRuc:''}" 
                                        data-inverted="">
                                        #{cobro.suscripcion.cliente.razonSocial}
                                    </td>
                                    <td>
                                        <h:outputText value="#{cobro.fecha}">
                                            <f:convertDateTime pattern="dd/MM/yy" />
                                        </h:outputText>
                                    </td>
                                    <td>#{cobro.concepto.nombre}</td>
                                    <td>
                                        #{empty cobro.detalleFactura?'(Sin factura)':''}
                                        #{not empty cobro.detalleFactura?cobro.detalleFactura.factura.talonarioFactura.codEstablecimiento.trim():''}#{not empty cobro.detalleFactura?'-':''}<h:outputText rendered="#{not empty cobro.detalleFactura}" value="#{cobro.detalleFactura.factura.nroFactura}">
                                            <f:convertNumber pattern="0000000" />
                                        </h:outputText>
                                    </td>
                                    <td class="right aligned">
                                        <h:outputText value="#{cobro.monto}">
                                            <f:convertNumber pattern="###,###,###,###" />
                                        </h:outputText>
                                    </td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                        <tfoot>
                            <tr><th colspan="7">
                                    <div id="cmb-reg-porpag" class="ui compact selection dropdown">
                                        <input name="in-reg-porpag" type="hidden" jsf:value="#{cobrosManBean.paginador.cantidadRegistrosPorPagina}"/>
                                        <i class="dropdown icon"></i>
                                        <div class="default text">Registros</div>
                                        <div class="menu">
                                            <div class="item" data-value="10">10 Ítems</div>
                                            <div class="item" data-value="20">20 Ítems</div>
                                            <div class="item" data-value="50">50 Ítems</div>
                                            <div class="item" data-value="100">100 Ítems</div>
                                            <div class="item" data-value="150">150 Ítems</div>
                                            <div class="item" data-value="200">200 Ítems</div>
                                        </div>
                                    </div>
                                    <span jsf:id="datos-paginacion">
                                        del #{cobrosManBean.paginador.posicionInicio} al #{cobrosManBean.paginador.posicionFin} (Total: #{cobrosManBean.paginador.totalRegistros})
                                    </span>

                                    <h:commandLink id="cml-camb-cant-items">
                                        <f:ajax execute="form-tabla:in-reg-porpag" render="form-tabla:menu-paginacion form-tabla:tbody-tabla form-tabla:datos-paginacion" />
                                    </h:commandLink>
                                    <div jsf:id="menu-paginacion" class="ui right floated pagination menu">
                                        <h:commandLink disabled="#{!cobrosManBean.paginador.desplazableIzquierda}" class="#{cobrosManBean.paginador.desplazableIzquierda?'icon item':'disabled icon item'}" action="#{cobrosManBean.paginador.desplazarIzquierdaPaginador()}">
                                            <i class="left chevron icon"></i>
                                            <f:ajax execute="@this" render="form-tabla:menu-paginacion form-tabla:tbody-tabla form-tabla:datos-paginacion" />
                                        </h:commandLink>
                                        <ui:repeat value="#{cobrosManBean.paginador.bloqueNumeracionPaginas}" var="pag" varStatus="pagStatus">
                                            <h:commandLink class="#{cobrosManBean.paginador.paginaActual==pag?'active item':'item'}" action="#{cobrosManBean.paginador.setPaginaActual(pag)}"> 
                                                #{pag}
                                                <f:ajax execute="@this" render="form-tabla:menu-paginacion form-tabla:tbody-tabla form-tabla:datos-paginacion" />
                                            </h:commandLink>
                                        </ui:repeat>
                                        <h:commandLink disabled="#{!cobrosManBean.paginador.desplazableDerecha}" class="#{cobrosManBean.paginador.desplazableDerecha?'icon item':'disabled icon item'}" action="#{cobrosManBean.paginador.desplazarDerechaPaginador()}">
                                            <i class="right chevron icon"></i>
                                            <f:ajax execute="@this" render="form-tabla:menu-paginacion form-tabla:tbody-tabla form-tabla:datos-paginacion" />
                                        </h:commandLink>
                                    </div>
                                </th>
                            </tr>
                        </tfoot>
                    </table>
                    <h:commandLink id="cml-recargar-cobros" style="display: none" action="#{cobrosManBean.recargarCobros()}">
                        <f:ajax execute="@this" render="form-tabla:tbody-tabla form-acciones" />
                    </h:commandLink>
                </h:form>
            </div>
            <div class="five wide column">
                <div class="ui pointing secondary menu">
                    <a class="item active" data-tab="filtros">Filtros</a>
                    <a class="item" data-tab="resumen">Resumen</a>
                </div>
                <div class="ui active tab" data-tab="filtros">
                    <h:form id="form-filtro" class="ui form">
                        <h:inputHidden id="in-tx-busc" value="#{cobrosManBean.txBusquedaCobro}" />
                        <div class="field">
                            <label><i class="red close link icon" onclick="$('#cmb-cobra').dropdown('clear')"/>Cobrador</label>
                            <div id="cmb-cobra" class="ui fluid search selection dropdown">
                                <input jsf:value="#{cobrosManBean.idCobradorSel}" name="in-idcobrador" type="hidden"/>
                                <i class="dropdown icon"></i>
                                <div class="default text">Todos los cobradores</div>
                                <div class="menu">
                                    <ui:repeat value="#{cobrosManBean.lstCobradores}" var="cobra" varStatus="cobraStatus">
                                        <div class="item" data-value="#{cobra.idfuncionario}">
                                            #{cobra.idfuncionario}-#{cobra.nombres} #{cobra.apellidos}
                                            (<h:outputText value="#{cobra.ci}">
                                                <f:convertNumber pattern="###,###,###,###" />
                                            </h:outputText>)
                                        </div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>

                        <div class="field">
                            <label><i onclick="limpiarConceptoFiltro()" class="red close link icon"/>Concepto</label>
                            <div id="cmb-concepto-filt" class="ui selection dropdown">
                                <input type="hidden" name="id-concepto" jsf:value="#{cobrosManBean.idConceptoFiltro}" />
                                <i class="dropdown icon"></i>
                                <div class="default text">Todos los conceptos</div>
                                <div class="menu">
                                    <ui:repeat value="#{conceptoMovimientoManBean.lstConceptos}" var="concepto" varStatus="conceptoStatus">
                                        <div class="item" data-value="#{concepto.idconcepto}">#{concepto.nombre}</div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                        <div class="field" data-tooltip="El usuario del sistema que registró el cobro" data-inverted="">
                            <label><i class="red close link icon" onclick="$('#cmb-usuario').dropdown('clear')"/>Usuario</label>
                            <div id="cmb-usuario" class="ui fluid search selection dropdown">
                                <input jsf:value="#{cobrosManBean.idFuncionarioRegistroSel}" name="in-idfuncionarioreg" type="hidden"/>
                                <i class="dropdown icon"></i>
                                <div class="default text">Todos los usuarios</div>
                                <div class="menu">
                                    <ui:repeat value="#{cobrosManBean.lstFuncionarios}" var="funcio" varStatus="funcioStatus">
                                        <div class="item" data-value="#{funcio.idfuncionario}">
                                            #{funcio.idfuncionario}-#{funcio.nombres} #{funcio.apellidos}
                                            (<h:outputText value="#{funcio.ci}">
                                                <f:convertNumber pattern="###,###,###,###" />
                                            </h:outputText>)
                                        </div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                        <div class="two fields">
                            <div class="field">
                                <label>Desde</label>
                                <div id="cal-inicio-cobro" class="ui calendar">
                                    <div class="ui input left icon">
                                        <i class="calendar icon" />
                                        <input jsf:value="#{cobrosManBean.fechaInicio}" id="fecha-inicio-cobro" type="text" placeholder="Fecha Inicio" />
                                    </div>
                                </div>
                            </div>
                            <div class="field">
                                <label>Hasta</label>
                                <div id="cal-fin-cobro" class="ui calendar">
                                    <div class="ui input left icon">
                                        <i class="calendar icon" />
                                        <input jsf:value="#{cobrosManBean.fechaFin}" id="fecha-fin-cobro" type="text" placeholder="Fecha Fin" />
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div jsf:rendered="#{sessionManBean.permisosAsignados(49)}" class="field">
                            <div class="ui checkbox">
                                <input name="chk-cobros-anulados" type="checkbox" jsf:value="#{cobrosManBean.anuladosFiltro}" />
                                <label>Anulados</label>
                            </div>
                        </div>
                        <h:commandLink id="cml-filtrar" class="ui right labeled icon button" action="#{cobrosManBean.filtrarCobros()}">
                            Filtrar
                            <i class="filter icon" />
                            <f:ajax execute="@form" render="form-tabla" onevent="function(data){ajaxFiltrar(data)}" />
                        </h:commandLink>
                    </h:form>
                </div>
                <div class="ui tab" data-tab="resumen">
                    <h:form id="form-resumen">
                        <h:commandLink rendered="#{sessionManBean.permisosAsignados(46)}" id="cml-actualizar-resumen" class="ui right labeled fluid icon button" action="#{cobrosManBean.actualizarResumen()}">
                            <i class="refresh icon" />
                            Actualizar
                            <f:ajax execute="@this" render="@form" onevent="function(data){ajaxActualizarResumen(data)}"/>
                        </h:commandLink>
                        <table jsf:id="tabla-totales" class="ui definition table" jsf:rendered="#{not empty cobrosManBean.lstResumenCobros}">
                            <tbody>
                                <ui:repeat value="#{cobrosManBean.lstResumenCobros}" var="itemresumen" varStatus="itemresumenStatus">
                                    <tr>
                                        <td>#{itemresumen.concepto}</td>
                                        <td class="right aligned">
                                            <h:outputText value="#{itemresumen.monto}">
                                                <f:convertNumber pattern="###,###,###,###" />
                                            </h:outputText>
                                        </td>
                                    </tr>
                                </ui:repeat>
                                <tr jsf:rendered="#{not empty cobrosManBean.lstResumenCobros}">
                                    <td>Total</td>
                                    <td class="right aligned">
                                        <h4 class="ui header">
                                            <h:outputText value="#{cobrosManBean.totalResumen}">
                                                <f:convertNumber pattern="###,###,###,###" />
                                            </h:outputText>
                                        </h4>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </h:form>
                </div>
            </div>
        </div>
        <h:form id="dlg-cpor-factura" class="ui fullscreen modal">
            <i class="close icon"></i>
            <div class="header">
                Cobros por factura
            </div>
            <div class="content">
                <div class="ui form">
                    <div class="fields">
                        <div class="twelve wide field">
                            <label>Número de factura</label>
                            <input jsf:id="in-nro-factagre" onkeypress="return buscarNroFactKey(event);" type="number" jsf:value="#{registroPorFacturaManBean.nroFactura}"/>
                        </div>
                        <div class="four wide field">
                            <label><br/></label>
                            <h:commandLink id="cml-agregar-factcob" class="ui fluid right labeled icon button" action="#{registroPorFacturaManBean.agregarFactura()}">
                                Agregar
                                <i class="add circle icon" />
                                <f:ajax execute="@form" render="dlg-cpor-factura:tipo-msg-cf dlg-cpor-factura:msg-cf dlg-cpor-factura:tabla-facturas-cob dlg-cpor-factura:cant-facturas-reg" onevent="function(data){ajaxAgregarFacturaCobro(data)}"  />
                            </h:commandLink>
                        </div>

                    </div>
                    <div class="field">
                        <div id="msg-agre-fc" style="display: none" class="ui info message">
                            <i class="close icon"></i>
                            <div class="header">
                                Registrar pago de facturas
                            </div>
                            <input jsf:id="tipo-msg-cf" type="hidden" jsf:value="#{registroPorFacturaManBean.tipomsg}" />
                            <h:outputText id="msg-cf" value="#{registroPorFacturaManBean.msgNuevoCobro}" />
                        </div>
                    </div>
                    <div class="field">
                        <label>Cantidad de facturas: <h:outputText id="cant-facturas-reg" value="#{registroPorFacturaManBean.lstFacturasCobro.size()}" /></label>
                        <table jsf:id="tabla-facturas-cob" class="ui table">
                            <thead>
                                <tr>
                                    <th>Nro. Factura</th>
                                    <th>Fecha</th>
                                    <th>Cliente</th>
                                    <th>Cobrador</th>
                                    <th>Monto</th>
                                    <th class="collapsing"></th>
                                </tr>
                            </thead>
                            <tbody>
                                <ui:repeat value="#{registroPorFacturaManBean.lstFacturasCobro}" var="factura" varStatus="facturaStatus">
                                    <tr>
                                        <td>#{factura.talonarioFactura.codEstablecimiento}-#{factura.nroFactura}</td>
                                        <td>
                                            <h:outputText value="#{factura.fecha}">
                                                <f:convertDateTime pattern="dd/MM/yyyy" />
                                            </h:outputText>
                                        </td>
                                        <td>
                                            #{factura.cliente.idcliente}-#{factura.cliente.razonSocial}
                                            <h:outputText rendered="#{factura.cliente.ci!=null}" value="(ruc:#{factura.cliente.ci}-#{factura.cliente.dvRuc})" />
                                        </td>
                                        <td>
                                            #{registroPorFacturaManBean.getDescripcionCobradorCliente(factura.cliente.idcliente)}
                                        </td>
                                        <td>
                                            <h:outputText value="#{factura.total}">
                                                <f:convertNumber pattern="###,###,###,###" />
                                            </h:outputText>
                                        </td>
                                        <td>
                                            <h:commandLink action="#{registroPorFacturaManBean.quitarFactura(facturaStatus.index)}">
                                                <i class="red remove icon" />
                                                <f:ajax execute="@form" render="dlg-cpor-factura:tipo-msg-cf dlg-cpor-factura:msg-cf dlg-cpor-factura:tabla-facturas-cob dlg-cpor-factura:cant-facturas-reg" onevent="function(data){ajaxAgregarFacturaCobro(data)}" />
                                            </h:commandLink>
                                        </td>
                                    </tr>
                                </ui:repeat>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="actions">

                <h:commandLink rendered="#{sessionManBean.permisosAsignados(18)}" class="ui green right labeled icon button" action="#{registroPorFacturaManBean.registrarCobrosFacturas()}">
                    Registrar y Finalizar
                    <i class="checkmark icon"></i>
                    <f:ajax execute="@form" render="dlg-cpor-factura:tabla-facturas-cob" onevent="function(data){ajaxAgregarFacturaCobro(data)}" />
                </h:commandLink>
                <div class="ui right labeled icon red deny button">
                    Cerrar
                    <i class="close icon" />
                </div>
            </div>
        </h:form>
        <script>
            const dateFormatter = {
                date: function (date, settings) {
                    if (!date)
                        return '';
                    var day = date.getDate();
                    var month = date.getMonth() + 1;
                    var year = date.getFullYear();
                    return day + '/' + month + '/' + year;
                }
            };
            const dateText = {
                days: ['D', 'L', 'M', 'M', 'J', 'V', 'S'],
                months: ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto', 'septiembre', 'octubre', 'noviembre', 'diciembre'],
                monthsShort: ['ene', 'feb', 'mar', 'abr', 'may', 'jun', 'jul', 'ago', 'sep', 'oct', 'nov', 'dic'],
                today: 'Hoy',
                now: 'Ahora',
                am: 'AM',
                pm: 'PM'
            };
            function ajaxActualizarResumen(data) {
                var s = data.status;
                switch (s) {
                    case 'begin':
                    {
                        $('#form-resumen\\:cml-actualizar-resumen').addClass('loading');
                        break;
                    }
                    case 'success':
                    {
                        $('#form-resumen\\:cml-actualizar-resumen').removeClass('loading');
                        break;
                    }
                }
            }
            function limpiarConceptoFiltro() {
                $('#cmb-concepto-filt').dropdown('clear');
            }
            function ajaxFiltrar(data) {
                var s = data.status;
                switch (s) {
                    case 'success':
                    {
                        $('#form-filtro\\:cml-filtrar').removeClass('disabled');
                        $('#form-filtro\\:cml-filtrar').removeClass('loading');
                        $("#cmb-reg-porpag").dropdown();
                        break;
                    }
                    case 'begin':
                    {
                        $('#form-filtro\\:cml-filtrar').addClass('disabled');
                        $('#form-filtro\\:cml-filtrar').addClass('loading');
                        break;
                    }
                }
            }
            function mostrarMsgCf() {
                if ($('#msg-agre-fc').css('display') === 'none') {
                    $('#msg-agre-fc').transition('fade');
                }
            }
            $('.message .close').on('click', function () {
                $(this).closest('.message').transition('fade');
            });
            function buscarNroFactKey(event) {
                console.log("keypress");
                if (event.which === 13 || event.keyCode === 13) {
                    $('#dlg-cpor-factura\\:cml-agregar-factcob').click();
                    return false;
                }
                return true;
            }

            function ajaxAgregarFacturaCobro(data) {
                var s = data.status;
                console.log('ajax busqueda');

                switch (s) {
                    case 'success':
                    {
                        $('#form-tabla\\:cml-recargar-cobros').click();
                        console.log('ajax busqueda exito');
                        $('#msg-agre-fc').removeClass('warning');
                        $('#msg-agre-fc').removeClass('info');
                        $('#msg-agre-fc').removeClass('error');
                        if ($('#dlg-cpor-factura\\:tipo-msg-cf').val() === '1') {

                            $('#msg-agre-fc').addClass('info');
                        } else if ($('#dlg-cpor-factura\\:tipo-msg-cf').val() === '2') {
                            $('#msg-agre-fc').addClass('warning');

                        } else if ($('#dlg-cpor-factura\\:tipo-msg-cf').val() === '3') {
                            $('#msg-agre-fc').addClass('error');
                        }
                        mostrarMsgCf();
                        $('#dlg-cpor-factura\\:in-nro-factagre').val('');
                        $('#dlg-cpor-factura').modal('refresh');
                        break;
                    }
                }
            }
            $('#btn-cobros-fact').click(function () {
                $('#dlg-cpor-factura').modal('show');
                return false;
            });
//            $('#form-filtro\\:chk-todos-cobradores').click(function () {
//                if ($('#form-filtro\\:chk-todos-cobradores').is(':checked')) {
//                    $('#cmb-cobra').addClass('disabled');
//                    console.log("checkeda");
//                } else {
//                    $('#cmb-cobra').removeClass('disabled');
//                    console.log("no checkeda");
//                }
//            });
            $(document).ready(function () {
                $('#cmb-reg-porpag').dropdown({
                    onChange: function () {
                        console.log("change cantidad items");
                        $('#form-tabla\\:cml-camb-cant-items').click();
                    }
                });
                $('.menu .item').tab();
                $("#cal-inicio-cobro").calendar({
                    monthFirst: false,
                    type: 'date',
                    text: dateText,
                    formatter: dateFormatter,
                    endCalendar: $('#cal-fin-cobro')
                });
                $("#cal-fin-cobro").calendar({
                    monthFirst: false,
                    type: 'date',
                    text: dateText,
                    formatter: dateFormatter,
                    startCalendar: $('#cal-inicio-cobro')
                });

                $('#cmb-cobra').dropdown({
                    apiSettings: {
                        url: '//' + location.host + restRootPath + '/buscarcobradordropdown?q={query}'
                    }
                });
                $('#form-filtro\\:cml-filtrar').click();
            });

            var timeOut = 0;
            $('#txf-buscar').on('input', function () {
                clearTimeout(timeOut);
                timeOut = setTimeout(function () {
                    $('#form-filtro\\:in-tx-busc').val($('#txf-buscar').val());
                    $('#form-filtro\\:cml-filtrar').click();
                }, 500);
            });
        </script>
    </ui:define>

</ui:composition>
